## libbpp-phyl 2.1.0

=== CMakeLists.txt ===
# CMake script for Bio++ PhylLib
# Author: Sylvain Gaillard and Julien Dutheil
# Created: 20/08/2009

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(bpp-phyl CXX)
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(CMAKE_CXX_FLAGS "-Wall -Wshadow -Weffc++ -Wconversion")
IF(NOT NO_VIRTUAL_COV)
  SET(NO_VIRTUAL_COV FALSE CACHE BOOL
      "Disable covariant return type with virtual inheritance, for compilers that do not support it."
      FORCE)
ENDIF(NOT NO_VIRTUAL_COV)

IF(NO_VIRTUAL_COV)
  MESSAGE("-- Covariant return with virtual inheritance disabled.")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_VIRTUAL_COV=1")
ENDIF(NO_VIRTUAL_COV)

IF(NOT NO_DEP_CHECK)
  SET(NO_DEP_CHECK FALSE CACHE BOOL
      "Disable dependencies check for building distribution only."
      FORCE)
ENDIF(NOT NO_DEP_CHECK)

IF(NO_DEP_CHECK)
  MESSAGE("-- Dependencies checking disabled. Only distribution can be built.")
ELSE(NO_DEP_CHECK)

# Libtool-like version number
# CURRENT:REVISION:AGE => file.so.(C-A).A.R
# current:  The most recent interface number that this library implements.
# revision: The implementation number of the current interface.
# age:      The difference between the newest and oldest interfaces that this
#           library implements.
# In other words, the library implements all the interface numbers in the
# range from number current - age to current.
SET(BPPPHYL_VERSION_CURRENT "10")
SET(BPPPHYL_VERSION_REVISION "3")
SET(BPPPHYL_VERSION_AGE "1")

# Effective version number computation
MATH(EXPR BPPPHYL_VERSION_MAJOR "${BPPPHYL_VERSION_CURRENT} - ${BPPPHYL_VERSION_AGE}")
SET(BPPPHYL_VERSION_MINOR ${BPPPHYL_VERSION_AGE})
SET(BPPPHYL_VERSION_PATCH ${BPPPHYL_VERSION_REVISION})
SET(BPPPHYL_VERSION "${BPPPHYL_VERSION_MAJOR}.${BPPPHYL_VERSION_MINOR}.${BPPPHYL_VERSION_PATCH}")

# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
IF(CMAKE_INSTALL_PREFIX)
  SET(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
ENDIF(CMAKE_INSTALL_PREFIX)

#here is a useful function:
MACRO(IMPROVED_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
  #start:
  FIND_PATH(${lib_name}_INCLUDE_DIR ${include_to_find})
  SET(${lib_name}_NAMES ${lib_name} ${lib_name}lib ${lib_name}dll)
  FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES} PATH_SUFFIXES lib${LIB_SUFFIX})

  IF(${lib_name}_LIBRARY)
    MESSAGE("-- Library ${lib_name} found here:")
    MESSAGE("   includes : ${${lib_name}_INCLUDE_DIR}")
    MESSAGE("   libraries: ${${lib_name}_LIBRARY}")
  ELSE(${lib_name}_LIBRARY)
    MESSAGE(FATAL_ERROR "${lib_name} required but not found.")
  ENDIF(${lib_name}_LIBRARY)
  
  #add the dependency:
  INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})
  SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})
ENDMACRO(IMPROVED_FIND_LIBRARY)

#Find the Bio++ libraries:
IMPROVED_FIND_LIBRARY(LIBS bpp-seq Bpp/Seq/Alphabet/Alphabet.h)
IMPROVED_FIND_LIBRARY(LIBS bpp-core Bpp/Clonable.h)

# Subdirectories
ADD_SUBDIRECTORY(src)

# Doxygen
FIND_PACKAGE(Doxygen)
IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET (apidoc cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  ADD_CUSTOM_TARGET (apidoc-stable cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
ENDIF (DOXYGEN_FOUND)

ENDIF(NO_DEP_CHECK)

# Packager
SET(CPACK_PACKAGE_NAME "libbpp-phyl")
SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
SET(CPACK_PACKAGE_VERSION "2.1.0")
SET(CPACK_PACKAGE_VERSION_MAJOR "2")
SET(CPACK_PACKAGE_VERSION_MINOR "1")
SET(CPACK_PACKAGE_VERSION_PATCH "0")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Phylogenetics library")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS.txt")
SET(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL.txt")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.cmake"
 ".*\\\\.git"
 ".*\\\\.gz"
 ".*\\\\.deb"
 ".*\\\\.rpm"
 ".*\\\\.dmg"
 ".*\\\\.sh"
 ".*\\\\..*\\\\.swp"
 "src/\\\\..*"
 "src/libbpp*"
 "test/tmp_*"
 "tmp_*"
 "debian/tmp"
 "debian/libbpp.*/"
 "debian/libbpp.*\\\\.so.*"
 "debian/libbpp.*\\\\.a"
 "debian/libbpp.*\\\\.substvars"
 "debian/libbpp.*\\\\.debhelper"
 "debian/debhelper\\\\.log"
 "html"
 "Phyl.tag"
 "Testing"
 "build-stamp"
 "install_manifest.txt"
 "DartConfiguration.tcl"
 ${CPACK_SOURCE_IGNORE_FILES}
)
IF (MACOS)
  SET(CPACK_GENERATOR "Bundle")
ENDIF()

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
SET(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
# 'clean' is not (yet) a first class target. However, we need to clean the directories before building the sources:
IF("${CMAKE_GENERATOR}" MATCHES "Make")
  ADD_CUSTOM_TARGET(make_clean
  COMMAND ${CMAKE_MAKE_PROGRAM} clean
  WORKING_DIRECTORY ${CMAKE_CURRENT_DIR}
  )
  ADD_DEPENDENCIES(dist make_clean)
ENDIF()

IF(NOT NO_DEP_CHECK)
IF (UNIX)
#This creates deb packages:
ADD_CUSTOM_TARGET(origdist COMMAND cp ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz ../${CPACK_DEBSOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(origdist dist)
ADD_CUSTOM_TARGET(deb dpkg-buildpackage -uc -us -i${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(deb origdist)

#This creates rpm packages:
ADD_CUSTOM_TARGET(rpm rpmbuild -ta ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(rpm dist)

ENDIF()

SET(CTEST_UPDATE_TYPE git)
SET(UPDATE_COMMAND "git")
SET(UPDATE_OPTIONS "")

ENABLE_TESTING()
INCLUDE(CTest)
IF (BUILD_TESTING)
  ADD_SUBDIRECTORY(test)
ENDIF(BUILD_TESTING)

ENDIF(NOT NO_DEP_CHECK)

=== src/CMakeLists.txt ===
# CMake script for Bio++ PhylLib
# Author: Sylvain Gaillard and Julien Dutheil
# Created: 20/08/2009

# File list
SET(CPP_FILES
  Bpp/Phyl/App/PhylogeneticsApplicationTools.cpp
  Bpp/Phyl/BipartitionList.cpp
  Bpp/Phyl/BipartitionTools.cpp
  Bpp/Phyl/Distance/AbstractAgglomerativeDistanceMethod.cpp
  Bpp/Phyl/Distance/BioNJ.cpp
  Bpp/Phyl/Distance/DistanceEstimation.cpp
  Bpp/Phyl/Distance/NeighborJoining.cpp
  Bpp/Phyl/Distance/PGMA.cpp
  Bpp/Phyl/Distance/HierarchicalClustering.cpp
  Bpp/Phyl/Graphics/AbstractDendrogramPlot.cpp
  Bpp/Phyl/Graphics/AbstractTreeDrawing.cpp
  Bpp/Phyl/Graphics/CladogramPlot.cpp
  Bpp/Phyl/Graphics/PhylogramPlot.cpp
  Bpp/Phyl/Graphics/TreeDrawingDisplayControler.cpp
  Bpp/Phyl/Graphics/TreeDrawingListener.cpp
  Bpp/Phyl/Io/IoDistanceMatrixFactory.cpp
  Bpp/Phyl/Io/IoTreeFactory.cpp
  Bpp/Phyl/Io/Newick.cpp
  Bpp/Phyl/Io/NexusIoTree.cpp
  Bpp/Phyl/Io/Nhx.cpp
  Bpp/Phyl/Io/PhylipDistanceMatrixFormat.cpp
  Bpp/Phyl/Io/IoPairedSiteLikelihoods.cpp
  Bpp/Phyl/Io/IoSubstitutionModelFactory.cpp
  Bpp/Phyl/Io/BppOSubstitutionModelFormat.cpp
  Bpp/Phyl/Io/IoFrequenciesSetFactory.cpp
  Bpp/Phyl/Io/BppOFrequenciesSetFormat.cpp
  Bpp/Phyl/Io/BppORateDistributionFormat.cpp
  Bpp/Phyl/Likelihood/AbstractDiscreteRatesAcrossSitesTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/AbstractHomogeneousTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/AbstractNonHomogeneousTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/AbstractTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/DRASDRTreeLikelihoodData.cpp
  Bpp/Phyl/Likelihood/DRASRTreeLikelihoodData.cpp
  Bpp/Phyl/Likelihood/DRHomogeneousMixedTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/DRHomogeneousTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/DRNonHomogeneousTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/DRTreeLikelihoodTools.cpp
  Bpp/Phyl/Likelihood/MarginalAncestralStateReconstruction.cpp
  Bpp/Phyl/Likelihood/NNIHomogeneousTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/PseudoNewtonOptimizer.cpp
  Bpp/Phyl/Likelihood/RASTools.cpp
  Bpp/Phyl/Likelihood/RHomogeneousClockTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/RHomogeneousMixedTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/RHomogeneousTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/RNonHomogeneousMixedTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/RNonHomogeneousTreeLikelihood.cpp
  Bpp/Phyl/Likelihood/TreeLikelihoodTools.cpp
  Bpp/Phyl/Likelihood/PairedSiteLikelihoods.cpp
  Bpp/Phyl/Likelihood/GlobalClockTreeLikelihoodFunctionWrapper.cpp
  Bpp/Phyl/Mapping/LaplaceSubstitutionCount.cpp
  Bpp/Phyl/Mapping/OneJumpSubstitutionCount.cpp
  Bpp/Phyl/Mapping/ProbabilisticSubstitutionMapping.cpp
  Bpp/Phyl/Mapping/NaiveSubstitutionCount.cpp
  Bpp/Phyl/Mapping/DecompositionSubstitutionCount.cpp
  Bpp/Phyl/Mapping/UniformizationSubstitutionCount.cpp
  Bpp/Phyl/Mapping/WeightedSubstitutionCount.cpp
  Bpp/Phyl/Mapping/SubstitutionMappingTools.cpp
  Bpp/Phyl/Model/StateMap.cpp
  Bpp/Phyl/Model/BinarySubstitutionModel.cpp
  Bpp/Phyl/Model/AbstractSubstitutionModel.cpp
  Bpp/Phyl/Model/AbstractBiblioSubstitutionModel.cpp
  Bpp/Phyl/Model/AbstractBiblioMixedSubstitutionModel.cpp
  Bpp/Phyl/Model/MarkovModulatedSubstitutionModel.cpp
  Bpp/Phyl/Model/AbstractMixedSubstitutionModel.cpp
  Bpp/Phyl/Model/MixtureOfASubstitutionModel.cpp
  Bpp/Phyl/Model/MixtureOfSubstitutionModels.cpp
  Bpp/Phyl/Model/RateDistributionFactory.cpp
  Bpp/Phyl/Model/RE08.cpp
  Bpp/Phyl/Model/SubstitutionModelFactory.cpp
  Bpp/Phyl/Model/SubstitutionModelSet.cpp
  Bpp/Phyl/Model/MixedSubstitutionModelSet.cpp
  Bpp/Phyl/Model/SubstitutionModelSetTools.cpp
  Bpp/Phyl/Model/AbstractWordSubstitutionModel.cpp
  Bpp/Phyl/Model/WordSubstitutionModel.cpp
  Bpp/Phyl/Model/Nucleotide/F84.cpp
  Bpp/Phyl/Model/Nucleotide/HKY85.cpp
  Bpp/Phyl/Model/Nucleotide/JCnuc.cpp
  Bpp/Phyl/Model/Nucleotide/GTR.cpp
  Bpp/Phyl/Model/Nucleotide/K80.cpp
  Bpp/Phyl/Model/Nucleotide/L95.cpp
  Bpp/Phyl/Model/Nucleotide/RN95.cpp
  Bpp/Phyl/Model/Nucleotide/RN95s.cpp
  Bpp/Phyl/Model/Nucleotide/SSR.cpp
  Bpp/Phyl/Model/Nucleotide/T92.cpp
  Bpp/Phyl/Model/Nucleotide/TN93.cpp
  Bpp/Phyl/Model/Nucleotide/gBGC.cpp
  Bpp/Phyl/Model/Nucleotide/YpR.cpp
  Bpp/Phyl/Model/Protein/DSO78.cpp
  Bpp/Phyl/Model/Protein/UserProteinSubstitutionModel.cpp
  Bpp/Phyl/Model/Protein/JCprot.cpp
  Bpp/Phyl/Model/Protein/JTT92.cpp
  Bpp/Phyl/Model/Protein/LG08.cpp
  Bpp/Phyl/Model/Protein/WAG01.cpp
  Bpp/Phyl/Model/Protein/LLG08_EHO.cpp
  Bpp/Phyl/Model/Protein/LLG08_EX2.cpp
  Bpp/Phyl/Model/Protein/LLG08_EX3.cpp
  Bpp/Phyl/Model/Protein/LLG08_UL2.cpp
  Bpp/Phyl/Model/Protein/LLG08_UL3.cpp
  Bpp/Phyl/Model/Protein/LGL08_CAT.cpp
  Bpp/Phyl/Model/Protein/Coala.cpp
  Bpp/Phyl/Model/Protein/CoalaCore.cpp
  Bpp/Phyl/Model/Codon/GY94.cpp
  Bpp/Phyl/Model/Codon/MG94.cpp
  Bpp/Phyl/Model/Codon/TripletSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/AbstractCodonSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/AbstractCodonFrequenciesSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/AbstractCodonPhaseFrequenciesSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/AbstractCodonDistanceSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/AbstractCodonFitnessSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/CodonDistanceSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/CodonDistanceFrequenciesSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/CodonDistancePhaseFrequenciesSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/CodonDistanceFitnessPhaseFrequenciesSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/CodonRateSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/CodonRateFrequenciesSubstitutionModel.cpp
  Bpp/Phyl/Model/Codon/YN98.cpp
  Bpp/Phyl/Model/Codon/YNGKP_M1.cpp
  Bpp/Phyl/Model/Codon/YNGKP_M2.cpp
  Bpp/Phyl/Model/Codon/YNGKP_M3.cpp
  Bpp/Phyl/Model/Codon/YNGKP_M7.cpp
  Bpp/Phyl/Model/Codon/YNGKP_M8.cpp
  Bpp/Phyl/Model/FrequenciesSet/FrequenciesSet.cpp
  Bpp/Phyl/Model/FrequenciesSet/NucleotideFrequenciesSet.cpp
  Bpp/Phyl/Model/FrequenciesSet/MvaFrequenciesSet.cpp
  Bpp/Phyl/Model/FrequenciesSet/WordFrequenciesSet.cpp
  Bpp/Phyl/Model/FrequenciesSet/CodonFrequenciesSet.cpp
  Bpp/Phyl/NNITopologySearch.cpp
  Bpp/Phyl/Node.cpp
  Bpp/Phyl/OptimizationTools.cpp
  Bpp/Phyl/Parsimony/AbstractTreeParsimonyScore.cpp
  Bpp/Phyl/Parsimony/DRTreeParsimonyData.cpp
  Bpp/Phyl/Parsimony/DRTreeParsimonyScore.cpp
  Bpp/Phyl/PatternTools.cpp
  Bpp/Phyl/PhyloStatistics.cpp
  Bpp/Phyl/Simulation/MutationProcess.cpp
  Bpp/Phyl/Simulation/NonHomogeneousSequenceSimulator.cpp
  Bpp/Phyl/Simulation/SequenceSimulationTools.cpp
  Bpp/Phyl/SitePatterns.cpp
  Bpp/Phyl/TreeExceptions.cpp
  Bpp/Phyl/TreeTemplateTools.cpp
  Bpp/Phyl/TreeTools.cpp  
  )
SET(H_FILES
  Bpp/Phyl/AncestralStateReconstruction.h
  Bpp/Phyl/App/PhylogeneticsApplicationTools.h
  Bpp/Phyl/BipartitionList.h
  Bpp/Phyl/BipartitionTools.h
  Bpp/Phyl/Distance/AbstractAgglomerativeDistanceMethod.h
  Bpp/Phyl/Distance/DistanceMethod.h
  Bpp/Phyl/Distance/BioNJ.h
  Bpp/Phyl/Distance/DistanceEstimation.h
  Bpp/Phyl/Distance/NeighborJoining.h
  Bpp/Phyl/Distance/PGMA.h
  Bpp/Phyl/Distance/HierarchicalClustering.h
  Bpp/Phyl/Graphics/AbstractDendrogramPlot.h
  Bpp/Phyl/Graphics/AbstractTreeDrawing.h
  Bpp/Phyl/Graphics/CladogramPlot.h
  Bpp/Phyl/Graphics/PhylogramPlot.h
  Bpp/Phyl/Graphics/TreeDrawingDisplayControler.h
  Bpp/Phyl/Graphics/TreeDrawing.h
  Bpp/Phyl/Graphics/TreeDrawingListener.h
  Bpp/Phyl/Io/IoDistanceMatrixFactory.h
  Bpp/Phyl/Io/IoDistanceMatrix.h
  Bpp/Phyl/Io/IoTreeFactory.h
  Bpp/Phyl/Io/IoTree.h
  Bpp/Phyl/Io/Newick.h
  Bpp/Phyl/Io/Nhx.h
  Bpp/Phyl/Io/NexusIoTree.h
  Bpp/Phyl/Io/PhylipDistanceMatrixFormat.h
  Bpp/Phyl/Io/IoPairedSiteLikelihoods.h
  Bpp/Phyl/Io/IoSubstitutionModel.h
  Bpp/Phyl/Io/IoSubstitutionModelFactory.h
  Bpp/Phyl/Io/BppOSubstitutionModelFormat.h
  Bpp/Phyl/Io/IoFrequenciesSet.h
  Bpp/Phyl/Io/IoFrequenciesSetFactory.h
  Bpp/Phyl/Io/BppOFrequenciesSetFormat.h
  Bpp/Phyl/Io/BppORateDistributionFormat.h
  Bpp/Phyl/Likelihood/AbstractDiscreteRatesAcrossSitesTreeLikelihood.h
  Bpp/Phyl/Likelihood/AbstractHomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/AbstractNonHomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/AbstractTreeLikelihoodData.h
  Bpp/Phyl/Likelihood/AbstractTreeLikelihood.h
  Bpp/Phyl/Likelihood/ClockTreeLikelihood.h
  Bpp/Phyl/Likelihood/DiscreteRatesAcrossSitesTreeLikelihood.h
  Bpp/Phyl/Likelihood/DRASDRTreeLikelihoodData.h
  Bpp/Phyl/Likelihood/DRASRTreeLikelihoodData.h
  Bpp/Phyl/Likelihood/DRHomogeneousMixedTreeLikelihood.h
  Bpp/Phyl/Likelihood/DRHomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/DRNonHomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/DRTreeLikelihood.h
  Bpp/Phyl/Likelihood/DRTreeLikelihoodTools.h
  Bpp/Phyl/Likelihood/HomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/MarginalAncestralStateReconstruction.h
  Bpp/Phyl/Likelihood/NNIHomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/NonHomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/PseudoNewtonOptimizer.h
  Bpp/Phyl/Likelihood/RASTools.h
  Bpp/Phyl/Likelihood/RHomogeneousClockTreeLikelihood.h
  Bpp/Phyl/Likelihood/RHomogeneousMixedTreeLikelihood.h
  Bpp/Phyl/Likelihood/RHomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/RNonHomogeneousMixedTreeLikelihood.h
  Bpp/Phyl/Likelihood/RNonHomogeneousTreeLikelihood.h
  Bpp/Phyl/Likelihood/SitePartitionTreeLikelihood.h
  Bpp/Phyl/Likelihood/TreeLikelihoodData.h
  Bpp/Phyl/Likelihood/TreeLikelihood.h
  Bpp/Phyl/Likelihood/TreeLikelihoodTools.h
  Bpp/Phyl/Likelihood/PairedSiteLikelihoods.h
  Bpp/Phyl/Likelihood/GlobalClockTreeLikelihoodFunctionWrapper.h
  Bpp/Phyl/Mapping/LaplaceSubstitutionCount.h
  Bpp/Phyl/Mapping/WeightedSubstitutionCount.h
  Bpp/Phyl/Mapping/OneJumpSubstitutionCount.h
  Bpp/Phyl/Mapping/ProbabilisticSubstitutionMapping.h
  Bpp/Phyl/Mapping/NaiveSubstitutionCount.h
  Bpp/Phyl/Mapping/DecompositionSubstitutionCount.h
  Bpp/Phyl/Mapping/UniformizationSubstitutionCount.h
  Bpp/Phyl/Mapping/SubstitutionRegister.h
  Bpp/Phyl/Mapping/SubstitutionCount.h
  Bpp/Phyl/Mapping/SubstitutionMapping.h
  Bpp/Phyl/Mapping/SubstitutionMappingTools.h
  Bpp/Phyl/Model/StateMap.h
  Bpp/Phyl/Model/AbstractSubstitutionModel.h
  Bpp/Phyl/Model/BinarySubstitutionModel.h
  Bpp/Phyl/Model/G2001.h
  Bpp/Phyl/Model/AbstractBiblioSubstitutionModel.h
  Bpp/Phyl/Model/AbstractBiblioMixedSubstitutionModel.h
  Bpp/Phyl/Model/MarkovModulatedSubstitutionModel.h
  Bpp/Phyl/Model/MixedSubstitutionModel.h
  Bpp/Phyl/Model/AbstractMixedSubstitutionModel.h
  Bpp/Phyl/Model/MixtureOfASubstitutionModel.h
  Bpp/Phyl/Model/MixtureOfSubstitutionModels.h
  Bpp/Phyl/Model/RateDistributionFactory.h
  Bpp/Phyl/Model/RE08.h
  Bpp/Phyl/Model/SubstitutionModelFactory.h
  Bpp/Phyl/Model/SubstitutionModel.h
  Bpp/Phyl/Model/SubstitutionModelSet.h
  Bpp/Phyl/Model/MixedSubstitutionModelSet.h
  Bpp/Phyl/Model/SubstitutionModelSetTools.h
  Bpp/Phyl/Model/TS98.h
  Bpp/Phyl/Model/AbstractWordSubstitutionModel.h
  Bpp/Phyl/Model/WordSubstitutionModel.h
  Bpp/Phyl/Model/Nucleotide/NucleotideSubstitutionModel.h
  Bpp/Phyl/Model/Nucleotide/F84.h
  Bpp/Phyl/Model/Nucleotide/HKY85.h
  Bpp/Phyl/Model/Nucleotide/JCnuc.h
  Bpp/Phyl/Model/Nucleotide/GTR.h
  Bpp/Phyl/Model/Nucleotide/K80.h
  Bpp/Phyl/Model/Nucleotide/L95.h
  Bpp/Phyl/Model/Nucleotide/RN95.h
  Bpp/Phyl/Model/Nucleotide/RN95s.h
  Bpp/Phyl/Model/Nucleotide/SSR.h
  Bpp/Phyl/Model/Nucleotide/T92.h
  Bpp/Phyl/Model/Nucleotide/TN93.h
  Bpp/Phyl/Model/Nucleotide/gBGC.h
  Bpp/Phyl/Model/Nucleotide/YpR.h
  Bpp/Phyl/Model/Protein/ProteinSubstitutionModel.h
  Bpp/Phyl/Model/Protein/DSO78.h
  Bpp/Phyl/Model/Protein/UserProteinSubstitutionModel.h
  Bpp/Phyl/Model/Protein/JCprot.h
  Bpp/Phyl/Model/Protein/JTT92.h
  Bpp/Phyl/Model/Protein/LG08.h
  Bpp/Phyl/Model/Protein/WAG01.h
  Bpp/Phyl/Model/Protein/LLG08_EHO.h
  Bpp/Phyl/Model/Protein/LLG08_EX2.h
  Bpp/Phyl/Model/Protein/LLG08_EX3.h
  Bpp/Phyl/Model/Protein/LLG08_UL2.h
  Bpp/Phyl/Model/Protein/LLG08_UL3.h
  Bpp/Phyl/Model/Protein/LGL08_CAT.h
  Bpp/Phyl/Model/Protein/Coala.h
  Bpp/Phyl/Model/Protein/CoalaCore.h
  Bpp/Phyl/Model/Codon/GY94.h
  Bpp/Phyl/Model/Codon/MG94.h
  Bpp/Phyl/Model/Codon/CodonSubstitutionModel.h

=== test/CMakeLists.txt ===
# CMake script for bpp-phyl unit tests
# Author: Julien Dutheil
# Created: 12/11/2010

MACRO(TEST_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
  #start:
  FIND_PATH(${lib_name}_INCLUDE_DIR ${include_to_find})

  SET(${lib_name}_NAMES ${lib_name} ${lib_name}.lib ${lib_name}.dll)
  FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES})
  IF(${lib_name}_LIBRARY)
    MESSAGE("-- Library ${lib_name} found here:")
    MESSAGE("   includes: ${${lib_name}_INCLUDE_DIR}")
    MESSAGE("   dynamic libraries: ${${lib_name}_LIBRARY}")
    MESSAGE(WARNING "Library ${lib_name} is already installed in the system tree. Test will be built against it. This may lead to unexpected results. You may want to do 'make install' before 'make test', or remove the installed version.")
  ELSE()
    SET(${lib_name}_LIBRARY "-L../src -lbpp-phyl")
    SET(${lib_name}_INCLUDE_DIR "../src/")
  ENDIF()
  INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})
  SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})
ENDMACRO(TEST_FIND_LIBRARY)

#Find the bpp-phyl library library:
TEST_FIND_LIBRARY(LIBS bpp-phyl Bpp/Phyl/Tree.h)

ADD_EXECUTABLE(test_tree test_tree.cpp)
TARGET_LINK_LIBRARIES(test_tree ${LIBS})
ADD_TEST(test_tree "test_tree")

ADD_EXECUTABLE(test_models test_models.cpp)
TARGET_LINK_LIBRARIES(test_models ${LIBS})
ADD_TEST(test_models "test_models")

ADD_EXECUTABLE(test_detailed_simulations test_detailed_simulations.cpp)
TARGET_LINK_LIBRARIES(test_detailed_simulations ${LIBS})
ADD_TEST(test_detailed_simulations "test_detailed_simulations")

ADD_EXECUTABLE(test_simulations test_simulations.cpp)
TARGET_LINK_LIBRARIES(test_simulations ${LIBS})
ADD_TEST(test_simulations "test_simulations")

ADD_EXECUTABLE(test_parsimony test_parsimony.cpp)
TARGET_LINK_LIBRARIES(test_parsimony ${LIBS})
ADD_TEST(test_parsimony "test_parsimony")

ADD_EXECUTABLE(test_likelihood test_likelihood.cpp)
TARGET_LINK_LIBRARIES(test_likelihood ${LIBS})
ADD_TEST(test_likelihood "test_likelihood")

ADD_EXECUTABLE(test_likelihood_nh test_likelihood_nh.cpp)
TARGET_LINK_LIBRARIES(test_likelihood_nh ${LIBS})
ADD_TEST(test_likelihood_nh "test_likelihood_nh")

ADD_EXECUTABLE(test_likelihood_clock test_likelihood_clock.cpp)
TARGET_LINK_LIBRARIES(test_likelihood_clock ${LIBS})
ADD_TEST(test_likelihood_clock "test_likelihood_clock")

ADD_EXECUTABLE(test_mapping test_mapping.cpp)
TARGET_LINK_LIBRARIES(test_mapping ${LIBS})
ADD_TEST(test_mapping "test_mapping")

ADD_EXECUTABLE(test_mapping_codon test_mapping_codon.cpp)
TARGET_LINK_LIBRARIES(test_mapping_codon ${LIBS})
ADD_TEST(test_mapping_codon "test_mapping_codon")

ADD_EXECUTABLE(test_nhx test_nhx.cpp)
TARGET_LINK_LIBRARIES(test_nhx ${LIBS})
ADD_TEST(test_nhx "test_nhx")

ADD_EXECUTABLE(test_bowker test_bowker.cpp)
TARGET_LINK_LIBRARIES(test_bowker ${LIBS})
ADD_TEST(test_bowker "test_bowker")

IF(UNIX)
  SET_PROPERTY(TEST test_detailed_simulations test_simulations test_parsimony test_models test_likelihood test_likelihood_nh test_likelihood_clock test_tree test_mapping test_mapping_codon test_nhx test_bowker PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
ENDIF()

IF(APPLE)
  SET_PROPERTY(TEST test_detailed_simulations test_simulations test_parsimony test_models test_likelihood test_likelihood_nh test_likelihood_clock test_tree test_mapping test_mapping_codon test_nhx test_bowker PROPERTY ENVIRONMENT "DYLD_LIBRARY_PATH=$ENV{DYLD_LIBRARY_PATH}:../src")
ENDIF()

IF(WIN32)
  SET(ENV{PATH} "$ENV{PATH};..\\src")
ENDIF()

=== debian/changelog ===
libbpp-phyl (2.1.0-1ubuntu3) wily; urgency=medium

  * And again, drop hardcoded dep.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 11 Aug 2015 13:19:39 +0100

libbpp-phyl (2.1.0-1ubuntu2) wily; urgency=medium

  * No-change rebuild against new libbpp-seq

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 11 Aug 2015 12:27:42 +0100

libbpp-phyl (2.1.0-1ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 04:41:54 +0000

libbpp-phyl (2.1.0-1) unstable; urgency=low

  * New RateDistribution classes
  * New models for protein sequences (COaLA)
  * Support for gaps in parsimony score
  * Improved and extended support for BppO
  * Several bugs fixed and warnings removed

 -- Julien Dutheil <julien.dutheil@univ-montp2.fr>  Thu, 07 Mar 2013 15:58:00 +0100

=== debian/control ===
Source: libbpp-phyl
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Loic Dachary <loic@dachary.org>
Uploaders: Julien Dutheil <julien.dutheil@univ-montp2.fr>
Build-Depends: debhelper (>= 5), cmake (>= 2.6),
  libbpp-seq-dev (>= 2.1.0)
Standards-Version: 3.9.1

Package: libbpp-phyl-dev
Section: libdevel
Architecture: any
Depends: libbpp-phyl9v5 (= ${binary:Version}), ${misc:Depends},
  libbpp-seq-dev (>= 2.1.0)
Description: Bio++ Phylogenetic library development files.
 Contains the Bio++ classes for phylogenetics.

Package: libbpp-phyl9v5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libbpp-phyl9
Replaces: libbpp-phyl9
Description: Bio++ Phylogenetic library.
 Contains the Bio++ classes for phylogenetics.

## libbpp-phyl 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -64,13 +64,13 @@
   SET(${lib_name}_NAMES ${lib_name} ${lib_name}lib ${lib_name}dll)
   FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES} PATH_SUFFIXES lib${LIB_SUFFIX})
 
-  IF(${lib_name}_LIBRARY)
+  IF(${${lib_name}_INCLUDE_DIR} MATCHES ${lib_name}_INCLUDE_DIR-NOTFOUND)
+    MESSAGE(FATAL_ERROR "${lib_name} required but not found.")
+  ELSE(${${lib_name}_INCLUDE_DIR} MATCHES ${lib_name}_INCLUDE_DIR-NOTFOUND)
     MESSAGE("-- Library ${lib_name} found here:")
     MESSAGE("   includes : ${${lib_name}_INCLUDE_DIR}")
     MESSAGE("   libraries: ${${lib_name}_LIBRARY}")
-  ELSE(${lib_name}_LIBRARY)
-    MESSAGE(FATAL_ERROR "${lib_name} required but not found.")
-  ENDIF(${lib_name}_LIBRARY)
+  ENDIF(${${lib_name}_INCLUDE_DIR} MATCHES ${lib_name}_INCLUDE_DIR-NOTFOUND)
   
   #add the dependency:
   INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})
@@ -103,9 +103,9 @@
 # Packager
 SET(CPACK_PACKAGE_NAME "libbpp-phyl")
 SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
-SET(CPACK_PACKAGE_VERSION "2.1.0")
+SET(CPACK_PACKAGE_VERSION "2.2.0")
 SET(CPACK_PACKAGE_VERSION_MAJOR "2")
-SET(CPACK_PACKAGE_VERSION_MINOR "1")
+SET(CPACK_PACKAGE_VERSION_MINOR "2")
 SET(CPACK_PACKAGE_VERSION_PATCH "0")
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ Phylogenetics library")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
@@ -123,7 +123,6 @@
  ".*\\\\.deb"
  ".*\\\\.rpm"
  ".*\\\\.dmg"
- ".*\\\\.sh"
  ".*\\\\..*\\\\.swp"
  "src/\\\\..*"
  "src/libbpp*"

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -53,6 +53,7 @@
   Bpp/Phyl/Likelihood/TreeLikelihoodTools.cpp
   Bpp/Phyl/Likelihood/PairedSiteLikelihoods.cpp
   Bpp/Phyl/Likelihood/GlobalClockTreeLikelihoodFunctionWrapper.cpp
+  Bpp/Phyl/Mapping/SubstitutionRegister.cpp
   Bpp/Phyl/Mapping/LaplaceSubstitutionCount.cpp
   Bpp/Phyl/Mapping/OneJumpSubstitutionCount.cpp
   Bpp/Phyl/Mapping/ProbabilisticSubstitutionMapping.cpp
@@ -61,6 +62,9 @@
   Bpp/Phyl/Mapping/UniformizationSubstitutionCount.cpp
   Bpp/Phyl/Mapping/WeightedSubstitutionCount.cpp
   Bpp/Phyl/Mapping/SubstitutionMappingTools.cpp
+  Bpp/Phyl/Mapping/DecompositionReward.cpp
+  Bpp/Phyl/Mapping/ProbabilisticRewardMapping.cpp
+  Bpp/Phyl/Mapping/RewardMappingTools.cpp
   Bpp/Phyl/Model/StateMap.cpp
   Bpp/Phyl/Model/BinarySubstitutionModel.cpp
   Bpp/Phyl/Model/AbstractSubstitutionModel.cpp
@@ -102,6 +106,7 @@
   Bpp/Phyl/Model/Protein/LLG08_EX3.cpp
   Bpp/Phyl/Model/Protein/LLG08_UL2.cpp
   Bpp/Phyl/Model/Protein/LLG08_UL3.cpp
+  Bpp/Phyl/Model/Protein/LG10_EX_EHO.cpp
   Bpp/Phyl/Model/Protein/LGL08_CAT.cpp
   Bpp/Phyl/Model/Protein/Coala.cpp
   Bpp/Phyl/Model/Protein/CoalaCore.cpp
@@ -221,8 +226,14 @@
   Bpp/Phyl/Mapping/UniformizationSubstitutionCount.h
   Bpp/Phyl/Mapping/SubstitutionRegister.h
   Bpp/Phyl/Mapping/SubstitutionCount.h
+  Bpp/Phyl/Mapping/Mapping.h
   Bpp/Phyl/Mapping/SubstitutionMapping.h
   Bpp/Phyl/Mapping/SubstitutionMappingTools.h
+  Bpp/Phyl/Mapping/Reward.h
+  Bpp/Phyl/Mapping/DecompositionReward.h
+  Bpp/Phyl/Mapping/RewardMapping.h
+  Bpp/Phyl/Mapping/RewardMappingTools.h
+  Bpp/Phyl/Mapping/ProbabilisticRewardMapping.h
   Bpp/Phyl/Model/StateMap.h
   Bpp/Phyl/Model/AbstractSubstitutionModel.h
   Bpp/Phyl/Model/BinarySubstitutionModel.h
@@ -264,15 +275,3 @@
   Bpp/Phyl/Model/Protein/JCprot.h
   Bpp/Phyl/Model/Protein/JTT92.h
   Bpp/Phyl/Model/Protein/LG08.h
-  Bpp/Phyl/Model/Protein/WAG01.h
-  Bpp/Phyl/Model/Protein/LLG08_EHO.h
-  Bpp/Phyl/Model/Protein/LLG08_EX2.h
-  Bpp/Phyl/Model/Protein/LLG08_EX3.h
-  Bpp/Phyl/Model/Protein/LLG08_UL2.h
-  Bpp/Phyl/Model/Protein/LLG08_UL3.h
-  Bpp/Phyl/Model/Protein/LGL08_CAT.h
-  Bpp/Phyl/Model/Protein/Coala.h
-  Bpp/Phyl/Model/Protein/CoalaCore.h
-  Bpp/Phyl/Model/Codon/GY94.h
-  Bpp/Phyl/Model/Codon/MG94.h
-  Bpp/Phyl/Model/Codon/CodonSubstitutionModel.h

=== debian/changelog ===
libbpp-phyl (2.2.0-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Revert v5 rename of library packages

 -- Andreas Tille <tille@debian.org>  Tue, 17 May 2016 10:02:30 +0200

libbpp-phyl (2.2.0-1) unstable; urgency=medium

  * New upstream version
  * Moved packaging to Git
  * Better description
  * Team maintenance in Debian Med team
  * cme fix dpkg-control
  * Source package section: science
  * Add watch file
  * debhelper 9
  * DEP5
  * short dh rules file using d-shlibs
  * Library transition
    Closes: #791094

 -- Andreas Tille <tille@debian.org>  Thu, 21 Apr 2016 14:16:41 +0200

=== debian/control ===
Source: libbpp-phyl
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Julien Dutheil <julien.dutheil@univ-montp2.fr>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               d-shlibs,
               libbpp-seq-dev (>= 2.2.0)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libbpp-phyl.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/libbpp-phyl.git
Homepage: http://biopp.univ-montp2.fr/wiki/index.php/Main_Page

Package: libbpp-phyl-dev
Architecture: any
Section: libdevel
Depends: libbpp-phyl9 (= ${binary:Version}),
         ${misc:Depends},
         libbpp-seq-dev (>= 2.2.0)
Description: Bio++ Phylogenetic library development files
 Bio++ is a set of C++ libraries for Bioinformatics, including sequence
 analysis, phylogenetics, molecular evolution and population genetics.
 Bio++ is Object Oriented and is designed to be both easy to use and
 computer efficient. Bio++ intends to help programmers to write computer
 expensive programs, by providing them a set of re-usable tools.
 .
 This package contains the static library and the header files ofthe
 Bio++ classes for phylogenetics.

Package: libbpp-phyl9
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libbpp-phyl9
Replaces: libbpp-phyl9
Description: Bio++ Phylogenetic library
 Bio++ is a set of C++ libraries for Bioinformatics, including sequence
 analysis, phylogenetics, molecular evolution and population genetics.
 Bio++ is Object Oriented and is designed to be both easy to use and
 computer efficient. Bio++ intends to help programmers to write computer
 expensive programs, by providing them a set of re-usable tools.
 .
 This package contains the Bio++ classes for phylogenetics.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

## When the following is set, the package does not build:
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
## So we need to live with:
## libbpp-phyl9v5: hardening-no-bindnow usr/lib/x86_64-linux-gnu/libbpp-phyl.so.9

%:
	dh $@

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --override s/libbpp-core2-dev/libbpp-core-dev/ \
		    --override s/libbpp-seq9-dev/libbpp-seq-dev/ \
		    --exclude-la \
                    --movedev debian/tmp/usr/include/* usr/include \
                    debian/tmp/usr/lib/*.so

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	# For the moment ignore:
	#  5/12 Test  #5: test_parsimony ...................***Failed    0.01 sec
	# Newick::read: failed to read from stream
	#
	# 92% tests passed, 1 tests failed out of 12
	dh_auto_test || true
endif

=== debian/watch ===
version=3

http://biopp.univ-montp2.fr/Repositories/sources/ bpp-phyl-(\d[\d.]+)\.tar\.gz
